/**erots
id: 5d07a4727b968a00737228ef
build: 7
source: 34876abc8f7d4d5c94a4f1e53d48b8e6
*/
$ui.render({
  props: {
    id: "mainView",
    navBarHidden: true,
    statusBarHidden: 1,
  },
  views: [
    {
      type: "web",
      props: {
        id: "web",
        url: "https://www.yikm.net/",
        script() {
          window.onload = function() {
            const links = document.querySelectorAll('a[target="_blank"]');
            for (let link of links) {
              link.removeAttribute("target");
            }
          };
        }
      },
      layout: $layout.fill,
      events: {
        decideNavigation: function(sender, action) {
          if(action.requestURL.startsWith("https://www.yikm.net/play")) {
                        $("web").scrollEnabled = false;
                      } else {
                        $("web").scrollEnabled = true;
                      }
          if (action.requestURL.startsWith("https://www.yikm.net/")) {
            return true;
          }
          return false;
        }
      }
    },
    {
      type: "canvas",
      props: {
        id: "closeButton",
        menu: {
          items: [
            {
              title: "返回上一页",
              handler: sender => {
                $("web").goBack();
              }
            },
            {
              title: "返回首页",
              handler: sender => {
                $("web").url = "https://www.yikm.net/";
              }
            },
            {
              title: "退出",
              destructive: true,
              handler: sender => {
                $delay(0.3, () => {
                  $app.close();
                });
              }
            }
          ]
        }
      },
      layout: function(make, view) {
        make.right.inset(20);
        make.top.inset(42);
        make.size.equalTo($size(20, 20));
      },
      events: {
        draw: function(view, ctx) {
          (ctx.fillColor = $color("darkGray")),
            (ctx.strokeColor = $color("darkGray"));
          ctx.setLineCap(1);
          ctx.setLineWidth(3);
          ctx.moveToPoint(2, view.frame.height / 2);
          ctx.addLineToPoint(view.frame.width / 2, 2);
          ctx.addLineToPoint(view.frame.width - 2, view.frame.height / 2);
          ctx.moveToPoint(view.frame.width / 2, 2);
          ctx.addLineToPoint(view.frame.width / 2, view.frame.height - 2);
          ctx.strokePath();
        },
        longPressed: function(info) {
          $("web").goBack();
        },
        tapped: function(sender) {
          showToastView($("mainView"), "#E74C3C", "长按执行更多操作");
        },
        touchesBegan: function(sender, location) {
          $device.taptic(1);
        }
      }
    },
    {
      type: "progress",
      props: {
        id: "volumeView",
        progressColor: $color("red"),
        trackColor: $color("clear"),
        value: $system.volume
      },
      layout: function(make, view) {
        make.top.inset(0);
        make.height.equalTo(2);
        make.width.equalTo(view.super);
        make.left.inset(0);
      }
    }
  ]
});

// $timer.schedule({
//   interval: 1,
//   handler: function() {
//     $console.info($system.volume);
//     $("volumeView").value = $system.volume
//     $("volumeView").relayout()
//   }
// });

$delay(2, () => {
  $ui.animate({
    duration: 1,
    animation: function() {
      $("volumeView").alpha = 0;
      $("closeButton").alpha = 0.4;
    }
  });
});

function showToastView(view, color, text, duration) {
  let time = new Date().getTime();
  let topInset = 20;
  let textSize = $text.sizeThatFits({
    text: text,
    width: view.width,
    font: $font(15)
  });
  if (duration === undefined) {
    duration = text.length / 5;
  }
  let showView = {
    type: "view",
    props: {
      id: "toastView",
      bgcolor: $color("clear"),
      alpha: 0,
      userInteractionEnabled: false,
      info: time
    },
    layout: function(make, view) {
      make.centerX.equalTo(view.super);
      make.top.inset(topInset);
      make.width.equalTo(textSize.width + 60);
      make.height.equalTo(30);
    },
    views: [
      {
        type: "blur",
        props: {
          style: 1, // 0 ~ 5
          radius: 5
        },
        layout: $layout.fill
      },
      {
        type: "image",
        props: {
          icon: $icon("009", $color(color), $size(16, 16)),
          bgcolor: $color("clear")
        },
        layout: function(make, view) {
          make.centerY.equalTo(view.super);
          make.size.equalTo($size(16, 16));
          make.left.inset(10);
        }
      },
      {
        type: "view",
        layout: function(make, view) {
          make.centerY.equalTo(view.super);
          make.left.equalTo(view.prev.right).inset(0);
          make.right.inset(10);
          make.height.equalTo(view.super);
        },
        views: [
          {
            type: "label",
            props: {
              text: text,
              bgcolor: $color("clear"),
              textColor: $color("black"),
              font: $font(15)
            },
            layout: function(make, view) {
              make.center.equalTo(view.super);
            }
          }
        ]
      }
    ]
  };
  if ($("toastView") != undefined) {
    $("toastView").remove();
  }
  view.add(showView);
  let fView = $("toastView");
  if (fView == undefined) {
    return 0;
  }
  fView.relayout();
  fView.updateLayout(function(make) {
    make.top.inset(topInset + 20);
  });
  $ui.animate({
    duration: 0.4,
    animation: function() {
      fView.alpha = 1.0;
      fView.relayout();
    },
    completion: function() {
      $delay(duration, function() {
        let fView = $("toastView");
        if (fView == undefined) {
          return 0;
        } else if (fView.info != time) {
          return 0;
        }
        fView.updateLayout(function(make) {
          make.top.inset(topInset);
        });
        $ui.animate({
          duration: 0.4,
          animation: function() {
            fView.alpha = 0.0;
            fView.relayout();
          },
          completion: function() {
            if (fView != undefined) {
              fView.remove();
            }
          }
        });
      });
    }
  });
}