const bridge = require("../../bridge");
const moduleName = "addin";

exports.list = () => {
  return bridge.invokeNative(moduleName, "list").results;
}

exports.categories = () => {
  return bridge.invokeNative(moduleName, "categories").results;
}

exports.current = () => {
  return bridge.invokeNative(moduleName, "current").value;
}

exports.save = args => {
  if (args.file) {
    args.file = bridge.toNativeFile(args.file);
  }
  return bridge.invokeNative(moduleName, "save", args).status;
}

exports.delete = name => {
  return bridge.invokeNative(moduleName, "delete", {
    name: String(name)
  }).status;
}

exports.run = args => {
  if (typeof args === "string") {
    args = {
      name: args
    }
  }
  return bridge.invokeNative(moduleName, "run", args).status;
}

exports.restart = () => {
  return bridge.invokeNative(moduleName, "restart").status;
}