const bridge = require("../../bridge");
const moduleName = "audio";

exports.status = () => {
  return bridge.invokeNative(moduleName, "status").value;
}

exports.duration = () => {
  return bridge.invokeNative(moduleName, "duration").value;
}

exports.offset = () => {
  return bridge.invokeNative(moduleName, "offset").value;
}

exports.play = args => {
  if (typeof args === "number") {
    args = {
      id: args
    };
  }

  if (typeof args === "string") {
    if (args.indexOf("http") === 0) {
      args = {
        url: args
      };
    } else {
      args = {
        path: args
      };
    }
  }

  bridge.invokeNative(moduleName, "play", {
    id: args.id,
    path: args.path,
    url: args.url,
    events: bridge.toNamedHandlers(args.events)
  });
}

exports.pause = () => {
  bridge.invokeNative(moduleName, "pause");
}

exports.resume = () => {
  bridge.invokeNative(moduleName, "resume");
}

exports.stop = () => {
  bridge.invokeNative(moduleName, "stop");
}

exports.seek = seconds => {
  bridge.invokeNative(moduleName, "seek", {
    seconds: seconds
  });
}