const util = require("util");
const bridge = require("../../bridge");
const moduleName = "clipboard";

exports.text = () => {
  const result = bridge.invokeNative(moduleName, "text");
  return util.format(result.text);
}

exports.setText = text => {
  bridge.invokeNative(moduleName, "setText", {
    text: util.format(text)
  });
}

exports.setTextLocalOnly = text => {
  bridge.invokeNative(moduleName, "setTextLocalOnly", {
    text: util.format(text)
  });
}

exports.image = () => {
  const image = bridge.invokeNative(moduleName, "image");
  return bridge.toNodeFile(image);
}

exports.setImage = file => {
  const image = bridge.toNativeFile(file);
  bridge.invokeNative(moduleName, "setImage", image);
}

exports.clear = () => {
  bridge.invokeNative(moduleName, "clear");
}