const bridge = require("../../bridge");
const moduleName = "device";

exports.info = () => {
  return bridge.invokeNative(moduleName, "info");
}

exports.isDarkMode = () => {
  return bridge.invokeNative(moduleName, "isDarkMode").value;
}

exports.isIphoneX = () => {
  return bridge.invokeNative(moduleName, "isIphoneX").value;
}

exports.isIphonePlus = () => {
  return bridge.invokeNative(moduleName, "isIphonePlus").value;
}

exports.isIpad = () => {
  return bridge.invokeNative(moduleName, "isIpad").value;
}

exports.isIpadPro = () => {
  return bridge.invokeNative(moduleName, "isIpadPro").value;
}

exports.space = () => {
  return bridge.invokeNative(moduleName, "space");
}

exports.ssid = () => {
  return bridge.invokeNative(moduleName, "ssid");
}

exports.networkType = () => {
  return bridge.invokeNative(moduleName, "networkType").value;
}

exports.wlanAddress = () => {
  return bridge.invokeNative(moduleName, "wlanAddress").value;
}

exports.hasTouchID = () => {
  return bridge.invokeNative(moduleName, "hasTouchID").value;
}

exports.hasFaceID = () => {
  return bridge.invokeNative(moduleName, "hasFaceID").value;
}

exports.taptic = level => {
  bridge.invokeNative(moduleName, "taptic", {
    level: level
  });
}

exports.isJailbroken = () => {
  return bridge.invokeNative(moduleName, "isJailbroken").value;
}

exports.isVoiceOverOn = () => {
  return bridge.invokeNative(moduleName, "isVoiceOverOn").value;
}