const bridge = require("../../bridge");
const moduleName = "drive";

exports.save = file => {
  return new Promise((resolve, reject) => {
    bridge.invokeNative(moduleName, "save", {
      file: bridge.toNativeFile(file)
    }, result => {
      resolve(result.path);
    });
  });
}

exports.open = args => {
  return new Promise((resolve, reject) => {
    bridge.invokeNative(moduleName, "open", args, file => {
      resolve(bridge.toNodeFile(file));
    });
  });
}