const bridge = require("../../bridge");
const moduleName = "location";

exports.available = () => {
  return bridge.invokeNative(moduleName, "available").value;
}

exports.fetch = args => {
  return new Promise((resolve, reject) => {
    bridge.invokeNative(moduleName, "fetch", args, location => {
      resolve(location);
    });
  });
}

exports.startUpdates = (args, handler) => {
  if (typeof args === "function") {
    handler = args;
    args = {};
  }

  bridge.invokeNative(moduleName, "startUpdates", args, location => {
    if (handler) {
      handler(location);
    }
  });
}

exports.trackHeading = (args, handler) => {
  if (typeof args === "function") {
    handler = args;
    args = {};
  }

  bridge.invokeNative(moduleName, "trackHeading", args, heading => {
    if (handler) {
      handler(heading);
    }
  });
}

exports.stopUpdates = () => {
  bridge.invokeNative(moduleName, "stopUpdates");
}

exports.select = () => {
  return new Promise((resolve, reject) => {
    bridge.invokeNative(moduleName, "select", location => {
      resolve(location);
    });
  });
}