const bridge = require("../../bridge");
const moduleName = "message";

exports.sms = args => {
  return _handle("sms", args);
}

exports.mail = args => {
  return _handle("mail", args);
}

function _handle(method, args) {
  args.attachments = (args.attachments || []).map(file => {
    return bridge.toNativeFile(file);
  });

  return new Promise((resolve, reject) => {
    bridge.invokeNative(moduleName, method, args, result => {
      resolve(result.success);
    });
  });
}