const bridge = require("../../bridge");
const moduleName = "push";

exports.schedule = args => {
  args.date = bridge.toNativeDate(args.date);
  args.attachments = (args.attachments || []).map(file => {
    return bridge.toNativeFile(file);
  });

  return new Promise((resolve, reject) => {
    bridge.invokeNative(moduleName, "schedule", args, result => {
      resolve(result);
    });
  });
}

exports.cancel = args => {
  bridge.invokeNative(moduleName, "cancel", args);
}

exports.clear = () => {
  bridge.invokeNative(moduleName, "clear");
}