const bridge = require("../../bridge");
const moduleName = "qrcode";

exports.encode = text => {
  const file = bridge.invokeNative(moduleName, "encode", {
    text: String(text)
  });
  return bridge.toNodeFile(file);
}

exports.decode = file => {
  const result = bridge.invokeNative(moduleName, "decode", {
    file: bridge.toNativeFile(file)
  });
  return result.text;
}

exports.scan = args => {
  return new Promise((resolve, reject) => {
    bridge.invokeNative(moduleName, "scan", args, result => {
      resolve(result.text);
    });
  });
}