const util = require("util");
const bridge = require("../../bridge");
const moduleName = "quicklook";

exports.text = text => {
  return _quicklook("text", {
    text: util.format(text)
  });
}

exports.file = file => {
  return _quicklook("file", {
    file: bridge.toNativeFile(file)
  });
}

exports.files = files => {
  return _quicklook("files", {
    files: files.map(file => bridge.toNativeFile(file))
  });
}

exports.json = json => {
  return _quicklook("json", {
    json: json
  });
}

exports.html = html => {
  return _quicklook("html", {
    html: html
  });
}

exports.markdown = markdown => {
  return _quicklook("markdown", {
    markdown: markdown
  });
}

function _quicklook(method, args) {
  return new Promise((resolve, reject) => {
    bridge.invokeNative(moduleName, method, args, resolve);
  });
}