const bridge = require("../../bridge");
const moduleName = "safari";

exports.open = (url, args) => {
  args = args || {};
  args.url = url;
  return new Promise((resolve, reject) => {
    bridge.invokeNative(moduleName, "open", args, resolve);
  });
}

exports.exec = args => {
  if (typeof args === "string") {
    args = {
      "script": args
    }
  }

  for (const [name, handler] of Object.entries(args)) {
    if (typeof handler === "function") {
      args[name] = bridge.createHandler(response => {
        handler(response.message);
      });
    }
  }

  return new Promise((resolve, reject) => {
    bridge.invokeNative(moduleName, "exec", args, response => {
      resolve(response.result);
    });
  });
}

exports.addReadingItem = args => {
  return bridge.invokeNative(moduleName, "addReadingItem", args).success;
}