const util = require("util");
const bridge = require("../../bridge");
const moduleName = "share";

exports.text = text => {
  return _share("text", {
    text: util.format(text)
  });
}

exports.texts = texts => {
  return _share("texts", {
    texts: texts.map(text => util.format(text))
  });
}

exports.file = file => {
  return _share("file", {
    file: bridge.toNativeFile(file)
  });
}

exports.files = files => {
  return _share("files", {
    files: files.map(file => bridge.toNativeFile(file))
  });
}

exports.url = url => {
  return _share("url", {
    url: url
  });
}

function _share(method, args) {
  return new Promise((resolve, reject) => {
    bridge.invokeNative(moduleName, method, args, result => {
      resolve(result.success);
    });
  });
}