const bridge = require("../../bridge");
const moduleName = "system";

exports.brightness = () => {
  return bridge.invokeNative(moduleName, "brightness").value;
}

exports.setBrightness = brightness => {
  bridge.invokeNative(moduleName, "setBrightness", {
    value: brightness
  });
}

exports.volume = () => {
  return bridge.invokeNative(moduleName, "volume").value;
}

exports.setVolume = volume => {
  bridge.invokeNative(moduleName, "setVolume", {
    value: volume
  });
}

exports.call = number => {
  bridge.invokeNative(moduleName, "call", {
    number: number
  });
}

exports.sms = number => {
  bridge.invokeNative(moduleName, "sms", {
    number: number
  });
}

exports.mailto = address => {
  bridge.invokeNative(moduleName, "mailto", {
    address: address
  });
}

exports.facetime = number => {
  bridge.invokeNative(moduleName, "facetime", {
    number: number
  });
}

exports.home = () => {
  bridge.invokeNative(moduleName, "home");
}