module.exports = {
  "!name": "node",
  "!define": {
    "contact": {
      "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/contact",
      "!doc": "Provides iOS contacts APIs.",
      "pick": {
        "!type": "fn(args: ?) -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/contact?id=contactpickobject-gt-promise",
        "!doc": "Select one or more contacts using the built-in picker."
      },
      "fetch": {
        "!type": "fn(args: ?) -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/contact?id=contactfetchobject-gt-promise",
        "!doc": "Search contacts using a keyword or group."
      },
      "create": {
        "!type": "fn(args: ?) -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/contact?id=contactcreateobject-gt-promise",
        "!doc": "Create a contact."
      },
      "save": {
        "!type": "fn(contact: ?) -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/contact?id=contactsaveobject-gt-promise",
        "!doc": "Save an updated contact."
      },
      "delete": {
        "!type": "fn(contacts: [?]) -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/contact?id=contactdeleteobject-gt-promise",
        "!doc": "Delete some contacts."
      },
      "fetchGroups": {
        "!type": "fn() -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/contact?id=contactfetchgroups-gt-promise",
        "!doc": "Get all contact groups."
      },
      "addGroup": {
        "!type": "fn(name: string) -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/contact?id=contactaddgroupstring-gt-promise",
        "!doc": "Create a new group."
      },
      "deleteGroup": {
        "!type": "fn(group: ?) -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/contact?id=contactdeletegroupobject-gt-promise",
        "!doc": "Delete a group."
      },
      "updateGroup": {
        "!type": "fn(group: ?) -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/contact?id=contactupdategroupobject-gt-promise",
        "!doc": "Save an updated group."
      },
      "addToGroup": {
        "!type": "fn(args: ?) -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/contact?id=contactaddtogroupobject-gt-promise",
        "!doc": "Add a contact into a group."
      },
      "removeFromGroup": {
        "!type": "fn(args: ?) -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/contact?id=contactremovefromgroupobject-gt-promise",
        "!doc": "Remove a contact from a group."
      }
    }
  }
}