module.exports = {
  "!name": "node",
  "!define": {
    "device": {
      "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/device",
      "!doc": "Provides some device APIs.",
      "info": {
        "!type": "fn() -> ?",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/device?id=deviceinfo",
        "!doc": "Returns the device information."
      },
      "isDarkMode": {
        "!type": "fn() -> bool",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/device?id=deviceisdarkmode",
        "!doc": "Detect whether the device is using dark mode."
      },
      "isIphoneX": {
        "!type": "fn() -> bool",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/device?id=deviceisxxx",
        "!doc": "Detect whether the device is iPhone X series."
      },
      "isIphonePlus": {
        "!type": "fn() -> bool",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/device?id=deviceisxxx",
        "!doc": "Detect whether the device is Plus series."
      },
      "isIpad": {
        "!type": "fn() -> bool",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/device?id=deviceisxxx",
        "!doc": "Detect whether the device is iPad series."
      },
      "isIpadPro": {
        "!type": "fn() -> bool",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/device?id=deviceisxxx",
        "!doc": "Detect whether the device is iPad Pro series."
      },
      "space": {
        "!type": "fn() -> ?",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/device?id=devicespace",
        "!doc": "Detect the device memory/disk space."
      },
      "ssid": {
        "!type": "fn() -> ?",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/device?id=devicessid",
        "!doc": "Get the current Wi-Fi SSID."
      },
      "networkType": {
        "!type": "fn() -> number",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/device?id=devicenetworktype",
        "!doc": "Get the current network type."
      },
      "wlanAddress": {
        "!type": "fn() -> string",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/device?id=devicewlanaddress",
        "!doc": "Get the current wlan address."
      },
      "hasTouchID": {
        "!type": "fn() -> bool",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/device?id=devicehastouchid",
        "!doc": "Check if the device supports Touch ID."
      },
      "hasFaceID": {
        "!type": "fn() -> bool",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/device?id=devicehasfaceid",
        "!doc": "Check if the device supports Face ID."
      },
      "taptic": {
        "!type": "fn(level: number)",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/device?id=devicetapticnumber",
        "!doc": "Trigger a taptic feedback if supported."
      },
      "isJailbroken": {
        "!type": "fn() -> bool",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/device?id=deviceisjailbroken",
        "!doc": "Check whether device is jailbroken."
      },
      "isVoiceOverOn": {
        "!type": "fn() -> bool",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/device?id=deviceisvoiceoveron",
        "!doc": "Check whether VoiceOver is running."
      }
    }
  }
}