module.exports = {
  "!name": "node",
  "!define": {
    "imagekit": {
      "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit",
      "!doc": "Image processing utilities.",
      "info": {
        "!type": "fn(image: +File) -> ?",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitinfofile",
        "!doc": "Get image information."
      },
      "grayscale": {
        "!type": "fn(image: +File) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitgrayscalefile",
        "!doc": "Get grayscaled image."
      },
      "invert": {
        "!type": "fn(image: +File) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitinvertfile",
        "!doc": "Invert colors."
      },
      "sepia": {
        "!type": "fn(image: +File) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitsepiafile",
        "!doc": "Apply sepia filter."
      },
      "adjustEnhance": {
        "!type": "fn(image: +File) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitadjustenhancefile",
        "!doc": "Enhance image automatically."
      },
      "adjustRedEye": {
        "!type": "fn(image: +File) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitadjustredeyefile",
        "!doc": "Red-eye adjustment."
      },
      "adjustBrightness": {
        "!type": "fn(image: +File, value: number) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitadjustbrightnessfile-value",
        "!doc": "Adjust brightness."
      },
      "adjustContrast": {
        "!type": "fn(image: +File, value: number) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitadjustcontrastfile-value",
        "!doc": "Adjust contrast."
      },
      "adjustGamma": {
        "!type": "fn(image: +File, value: number) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitadjustgammafile-value",
        "!doc": "Adjust gamma value."
      },
      "adjustOpacity": {
        "!type": "fn(image: +File, value: number) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitadjustopacityfile-value",
        "!doc": "Adjust opacity."
      },
      "blur": {
        "!type": "fn(image: +File, bias: number) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitblurfile-bias",
        "!doc": "Apply gaussian blur."
      },
      "emboss": {
        "!type": "fn(image: +File, bias: number) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitembossfile-bias",
        "!doc": "Emboss effect."
      },
      "sharpen": {
        "!type": "fn(image: +File, bias: number) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitsharpenfile-bias",
        "!doc": "Sharpen."
      },
      "unsharpen": {
        "!type": "fn(image: +File, bias: number) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitunsharpenfile-bias",
        "!doc": "Unsharpen."
      },
      "detectEdge": {
        "!type": "fn(image: +File, bias: number) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitdetectedgesource-bias",
        "!doc": "Edge detection."
      },
      "mask": {
        "!type": "fn(image: +File, mask: +File) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitmaskfile-mask",
        "!doc": "Crop an image with mask."
      },
      "reflect": {
        "!type": "fn(image: +File, height: number, fromAlpha: number, toAlpha: number) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitreflectfile-height-fromalpha-toalpha",
        "!doc": "Create an up-down reflected image, from height position, change alpha value from fromAlpha to toAlpha."
      },
      "cropTo": {
        "!type": "fn(image: +File, size: ?, mode: number) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitcroptofile-size-mode",
        "!doc": "Crop an image."
      },
      "scaleBy": {
        "!type": "fn(image: +File, scale: number) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitscalebyfile-value",
        "!doc": "Resize an image with scale."
      },
      "scaleTo": {
        "!type": "fn(image: +File, size: ?, mode: number) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitscaletofile-size-mode",
        "!doc": "Resize an image to a specific size."
      },
      "scaleFill": {
        "!type": "fn(image: +File, size: ?) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitscalefillfile-size",
        "!doc": "Resize an image using scaleFill mode."
      },
      "scaleAspectFit": {
        "!type": "fn(image: +File, size: ?) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitscaleaspectfitfile-size",
        "!doc": "Resize an image using scaleAspectFit mode."
      },
      "scaleAspectFill": {
        "!type": "fn(image: +File, size: ?) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitscaleaspectfillfile-size",
        "!doc": "Resize an image using scaleAspectFill mode."
      },
      "rotate": {
        "!type": "fn(image: +File, radians: number) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitrotatefile-radians",
        "!doc": "Rotate an image (it may change the size)."
      },
      "rotatePixels": {
        "!type": "fn(image: +File, radians: number) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitrotatepixelsfile-radians",
        "!doc": "Rotate an image (keeps the image size, some contents might be clipped)."
      },
      "flip": {
        "!type": "fn(image: +File, mode: number) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitflipfile-mode",
        "!doc": "Flip an image."
      },
      "concatenate": {
        "!type": "fn(images: [+File], space: number, mode: number) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitconcatenatefiles-space-mode",
        "!doc": "Concatenate images with space."
      },
      "combine": {
        "!type": "fn(image: +File, mask: +File) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitcombinefile-mask-mode",
        "!doc": "Add mask directly on image."
      },
      "rounded": {
        "!type": "fn(image: +File, radius: number) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitroundedfile-radius",
        "!doc": "Get an image with rounded corners."
      },
      "circular": {
        "!type": "fn(image: +File) -> +Buffer",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitcircularimage",
        "!doc": "Get a circular image, it will be centered and clipped if the source image isn't a square."
      },
      "extractGIF": {
        "!type": "fn(data: +File) -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitextractgifdata-gt-promise",
        "!doc": "Extract GIF data to frames."
      },
      "makeGIF": {
        "!type": "fn(source: ?, options: ?) -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitmakegifsource-options-gt-promise",
        "!doc": "Make GIF with image array or video data."
      },
      "makeVideo": {
        "!type": "fn(source: ?, options: ?) -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/imagekit?id=imagekitmakevideosource-options-gt-promise",
        "!doc": "Make video with image array or GIF data."
      }
    }
  }
}