module.exports = {
  "!name": "node",
  "!define": {
    "location": {
      "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/location",
      "!doc": "Provides device location APIs.",
      "available": {
        "!type": "fn() -> bool",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/location?id=locationavailable",
        "!doc": "Check whether location service is available."
      },
      "fetch": {
        "!type": "fn(args: ?) -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/location?id=locationfetch-gt-promise",
        "!doc": "Get the current location."
      },
      "startUpdates": {
        "!type": "fn(args: ?, handler: fn(result: ?))",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/location?id=locationstartupdatesobject",
        "!doc": "Start observing the location updates."
      },
      "trackHeading": {
        "!type": "fn(args: ?, handler: fn(result: ?))",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/location?id=locationtrackheadingobject",
        "!doc": "Track heading changes."
      },
      "stopUpdates": {
        "!type": "fn(args: ?)",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/location?id=locationstopupdates",
        "!doc": "Stop location updates."
      },
      "select": {
        "!type": "fn() -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/location?id=locationselect-gt-promise",
        "!doc": "Select a location using the JSBox built-in map component."
      }
    }
  }
}