module.exports = {
  "!name": "node",
  "!define": {
    "photo": {
      "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/photo",
      "!doc": "Provides APIs for the iOS Photos app.",
      "take": {
        "!type": "fn() -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/photo?id=phototake-gt-promise",
        "!doc": "Take a photo using the built-in camera."
      },
      "pick": {
        "!type": "fn(args: ?) -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/photo?id=photopickobject-gt-promise",
        "!doc": "Select a photo from the iOS photo library."
      },
      "scan": {
        "!type": "fn() -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/photo?id=photoscan-gt-promise",
        "!doc": "Scan documents using the iOS built-in documents scanner."
      },
      "save": {
        "!type": "fn(image: +File) -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/photo?id=photosavefile-gt-promise",
        "!doc": "Save a File format photo to the iOS photo library."
      },
      "fetch": {
        "!type": "fn(args: ?) -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/photo?id=photofetchobject-gt-promise",
        "!doc": "Fetch photos in the iOS photo library."
      },
      "delete": {
        "!type": "fn(args: ?) -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/photo?id=photodeleteobject-gt-promise",
        "!doc": "Delete some photos in the iOS photo library."
      }
    }
  }
}