module.exports = {
  "!name": "node",
  "!define": {
    "system": {
      "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/system",
      "!doc": "Provides some system-related APIs.",
      "brightness": {
        "!type": "fn() -> number",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/system?id=systembrightness",
        "!doc": "Get the current brightness."
      },
      "setBrightness": {
        "!type": "fn(value: number)",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/system?id=systemsetbrightnessnumber",
        "!doc": "Set the current brightness."
      },
      "volume": {
        "!type": "fn() -> number",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/system?id=systemvolume",
        "!doc": "Get the current volume."
      },
      "setVolume": {
        "!type": "fn(value: number)",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/system?id=systemsetvolumenumber",
        "!doc": "Set the current volume."
      },
      "call": {
        "!type": "fn(number: string)",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/system?id=systemcallnumber",
        "!doc": "Make a phone call."
      },
      "sms": {
        "!type": "fn(number: string)",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/system?id=systemsmsnumber",
        "!doc": "Send a text message."
      },
      "mailto": {
        "!type": "fn(address: string)",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/system?id=systemmailtostring",
        "!doc": "Send an email."
      },
      "facetime": {
        "!type": "fn(id: string)",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/system?id=systemfacetimestring",
        "!doc": "Initiate a FaceTime session."
      },
      "home": {
        "!type": "fn()",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/system?id=systemhome",
        "!doc": "Returns to the iOS home screen."
      }
    }
  }
}