module.exports = {
  "!name": "node",
  "!define": {
    "ui": {
      "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/ui",
      "!doc": "Provides some UI components.",
      "alert": {
        "!type": "fn(args: ?)",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/ui?id=uialertobject",
        "!doc": "Present an alert."
      },
      "action": {
        "!type": "fn(args: ?)",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/ui?id=uiactionobject",
        "!doc": "Present an action sheet."
      },
      "menu": {
        "!type": "fn(options: [string]) -> +Promise",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/ui?id=uimenuobject-gt-promise",
        "!doc": "Present a menu for choosing an option."
      },
      "toast": {
        "!type": "fn(message: string, delay: number)",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/ui?id=uitoaststring-number",
        "!doc": "Present a toast, it will be removed automatically after a delay."
      },
      "success": {
        "!type": "fn(message: string, delay: number)",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/ui?id=uisuccessstring-number",
        "!doc": "Present a success message, it will be removed automatically after a delay."
      },
      "warning": {
        "!type": "fn(message: string, delay: number)",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/ui?id=uiwarningstring-number",
        "!doc": "Present a warning message, it will be removed automatically after a delay."
      },
      "error": {
        "!type": "fn(message: string, delay: number)",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/ui?id=uierrorstring-number",
        "!doc": "Present an error message, it will be removed automatically after a delay."
      },
      "clearToast": {
        "!type": "fn()",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/ui?id=uicleartoast",
        "!doc": "Clears all toast on the screen."
      },
      "showHUD": {
        "!type": "fn(message: string)",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/ui?id=uishowhudstring",
        "!doc": "Show a HUD message."
      },
      "hideHUD": {
        "!type": "fn()",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/ui?id=uihidehud",
        "!doc": "Hide HUD message on the screen."
      },
      "showProgress": {
        "!type": "fn(value: number, message: string)",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/ui?id=uishowprogressnumber-string",
        "!doc": "Display a loading progress bar (0 ~ 1)."
      },
      "hideProgress": {
        "!type": "fn()",
        "!url": "https://cyanzhong.github.io/jsbox-nodejs/#/en/native-modules/ui?id=uihideprogress",
        "!doc": "Hide the loading progress bar on the screen."
      }
    }
  }
}